function RegisterController(OperatorController, OperatorRepository, ScreenService, UtilitiesService, RegisterService, RegisterClosingPayments, WindowService, PrinterService, RegisterOpen, RegisterClose, GeneralFunctions, CarrinhoDesistencia, Query, PerifericosService) {

	var self = this;

	this.openRegister = function (widget) {
		var rowChangeFunds = widget.currentRow;
		rowChangeFunds.VRMOVIVEND = UtilitiesService.getFloat(rowChangeFunds.VRMOVIVEND);
		if (rowChangeFunds.VRMOVIVEND == null || isNaN(rowChangeFunds.VRMOVIVEND)) {
			ScreenService.showMessage('Fundo de troco inválido.');
		} else if (rowChangeFunds.VRMOVIVEND < 0) {
			ScreenService.showMessage('Fundo de troco não pode ser menor que 0.');
		} else {
			OperatorRepository.findOne().then(function (operatorData) {
				if(operatorData.IDULTFECHAMEN == 'S'){
					ScreenService.showMessage("Caixa fechado. O último fechamento já foi realizado.").then(function (){
						WindowService.openWindow("login");
					});
				}
				RegisterService.openRegister(operatorData.chave, rowChangeFunds.VRMOVIVEND, operatorData.stNomeDispositivo||null).then(function (registerOpen) {
					registerOpen = registerOpen[0];
					if (_.get(registerOpen, 'dadosImpressao.paramsImpressora')) {
						PerifericosService.print(registerOpen.dadosImpressao.paramsImpressora).then(function () {
							self.handleOpenRegister(false);
						});
					} else {
						if (!_.isEmpty(registerOpen.dadosImpressao)) {
							var openRegisterText = registerOpen.dadosImpressao.open;
							var registerWidget = widget.container.getWidget('report');

							if (operatorData.IDMODEIMPRES == '25') {
								openRegisterText = _.join(_.split(openRegisterText, ' | '), "\n");
							}
							registerWidget.setCurrentRow({ 'report': openRegisterText });
							ScreenService.openPopup(registerWidget);
						} else {
							self.handleOpenRegister(false);
						}
					}
				});
			});
		}
	};

	this.printOpenRegister = function () {
		RegisterOpen.findOne().then(function (registerOpen) {
			PrinterService.printerCommand(PrinterService.TEXT_COMMAND, registerOpen.dadosImpressao.open);
			self.printerSpaceCommand(2);
			if(!_.isEmpty(PrinterService.TEXT_COMMAND)) {
			PrinterService.printerInit().then(function (result) {
				if (result.error)
					ScreenService.alertNotification(result.message);
			});
		}
			self.handleOpenRegister(true);
		});
	};

	this.printerSpaceCommand = function (max) {
		for (var i = 0; i < max; i++) {
			PrinterService.printerSpaceCommand();
		}
	};

	this.handleOpenRegister = function (closePopup) {
		if (closePopup) {
			ScreenService.closePopup();
		}

		OperatorRepository.findOne().then(function (operatorData) {
			if (operatorData.IDTPTEF === '5' && operatorData.IDCOLETOR === 'N' && !Util.isDesktop()) {
				GeneralFunctions.sitefTableLoad();
				GeneralFunctions.exportLogs(false);
			}

			OperatorController.bindedDoLogin();
		}.bind(this));
	};

	this.closeRegister = function (paymentGrid) {
		OperatorRepository.findOne().then(function (operatorData) {
			var TIPORECE = paymentGrid.dataSource.data;
			if ((TIPORECE.length === 0) || (validPayments(TIPORECE))) {
				self.confirmaImpressoes(operatorData.IDBLOQMAISABERT,operatorData.IDEMIRELPROD).then(function(arrRelatorios){
					stIDULTFECHAMEN = arrRelatorios.ultimoFechamento ? 'S' : 'N';
					RegisterService.closeRegister(operatorData.chave, TIPORECE, stIDULTFECHAMEN, arrRelatorios||[] ).then(function (registerClose) {
						CarrinhoDesistencia.remove(Query.build());
						registerClose = registerClose[0];
						if (_.get(registerClose, 'dadosImpressao.paramsImpressora')) {
							PerifericosService.print(registerClose.dadosImpressao.paramsImpressora).then(function () {
								self.handleCloseRegister(false);
							});
						} else {
							if (!_.isEmpty(registerClose.dadosImpressao)) {
								delete registerClose.dadosImpressao.printerParams;
								var registerWidget = paymentGrid.container.getWidget('report');
								if (operatorData.IDMODEIMPRES == '25') {
									_.forEach(registerClose.dadosImpressao, function (value, key) {
										registerClose.dadosImpressao[key] = _.join(_.split(value, ' | '), "\n");
									}.bind(this));
								}
								registerWidget.setCurrentRow({
									'report': _.join(_.values(registerClose.dadosImpressao),
										"\n\n******************************\n\n")
								});
								ScreenService.openPopup(registerWidget);
							} else {
								self.handleCloseRegister(false);
							}
						}
					});
				});
			}
		});
	};

	this.confirmaImpressoes = function(stIDBLOQMAISABERT, stIDEMIRELPROD){
		// se for o ultimo fechamento d odia impreme obrigatoriamente o relatorio de fechamento Total Dia
		// se não for o ultimo fechamento do dia pergunta se deseja impreimir o relatorio de fechamento Total Dia 

		arrRelatorios=[];
		arrRelatorios.fechamento=false;
		arrRelatorios.fechamentoTotalDia=false;		
		arrRelatorios.ultimoFechamento=false;
		arrRelatorios.produtos=false;
		return new Promise(function(fnResolve) {
			ScreenService.confirmMessage(
				"Confirma a impressão do Relatorio de Fechamento?", 'question',
				function () {
					arrRelatorios.fechamento = true;
					fnResolve(arrRelatorios);
				},
				function () {
					fnResolve(arrRelatorios);
				}
			);
		}).then(function(arrRelatorios){
			return new Promise(function(fnResolve) {
				if (stIDEMIRELPROD == 'S') {
					ScreenService.confirmMessage(
						"Deseja emitir o relatório de produtos vendidos?", 'question',
						function () {
							arrRelatorios.produtos = true;
							fnResolve(arrRelatorios);
						},
						function () {
							fnResolve(arrRelatorios);
						}
					);
				} else {
					fnResolve(arrRelatorios);
				}
			}).then(function(arrRelatorios){
				return new Promise(function(fnResolve) {
					if (stIDBLOQMAISABERT == 'S'){
						return self.ultimoFechamento(stIDBLOQMAISABERT).then(function(stIDULTFECHAMEN){
							arrRelatorios.fechamentoTotalDia = (stIDULTFECHAMEN == 'S');
							arrRelatorios.ultimoFechamento = (stIDULTFECHAMEN == 'S');
							fnResolve(arrRelatorios);
						});
					} else {
						arrRelatorios.ultimoFechamento = false;
						ScreenService.confirmMessage(
							"Confirma a impressão do Relatorio de Fechamento Final (Total do Dia) ?", 'question',
							function () {
								arrRelatorios.fechamentoTotalDia = true;
								fnResolve(arrRelatorios);
							},
							function () {
								fnResolve(arrRelatorios);
							}
						);
					}					
				}).then(function(arrRelatorios){
					return new Promise(function(fnResolve) {
						if (stIDBLOQMAISABERT == 'S' && arrRelatorios.ultimoFechamento == false){
							ScreenService.confirmMessage(
								"Confirma a impressão do Relatorio de Fechamento Final (Total do Dia) ?", 'question',
								function () {
									arrRelatorios.fechamentoTotalDia = true;
									fnResolve(arrRelatorios);
								},
								function () {
									fnResolve(arrRelatorios);
								}
							);
						} else {
							fnResolve(arrRelatorios);
						}						
					});
				});
			});
		});
	};

	this.ultimoFechamento = function(setIDBLOQMAISABERT){
		return new Promise(function(fnResolve) {			
			if (setIDBLOQMAISABERT == 'S') {
				ScreenService.confirmMessage(
					"Este é o último fechamento do dia?", 'question',
					function () {
						fnResolve("S");
					},
					function () {
						fnResolve("N");
					}
				);
			} else {
				fnResolve("N");
			}
		});
	};

	this.printCloseRegister = function () {
		RegisterClose.findOne().then(function (registerClose) {
			if (_.isEmpty(registerClose.dadosImpressao)) {
				self.handleCloseRegister(true);
			}
			if (!Array.isArray(registerClose.dadosImpressao)) {
				var textoImpressao = '';
				_.forEach(registerClose.dadosImpressao, function (impressData) {
					if(typeof(impressData) === 'string') {
						PrinterService.printerCommand(PrinterService.TEXT_COMMAND, impressData + (
							operatorData.IDMODEIMPRES !='27'?
							'\n'+'******************************'+'\n':
							''
						));
					}
				});
			} else {
				for (var i in registerClose.dadosImpressao) {
					PrinterService.printerCommand(PrinterService.TEXT_COMMAND, registerClose.dadosImpressao[i] + (
						operatorData.IDMODEIMPRES !='27'?
						'\n'+'******************************'+'\n':
						''
					));
				}
			}
			if(operatorData.IDMODEIMPRES !='27') {
			self.printerSpaceCommand(2);
			}
			if(!_.isEmpty(PrinterService.TEXT_COMMAND)) {
				PrinterService.printerInit().then(function (result) {
					if (result.error)
						ScreenService.alertNotification(result.message);
				});
			}
			self.handleCloseRegister(true);
		}.bind(this));
	};

	this.handleCloseRegister = function (closePopup) {
		if (closePopup) {
			ScreenService.closePopup();
		}
		if (RegisterService.getClosingOnLogin()) {
			RegisterService.setClosingOnLogin(false);
			WindowService.openWindow('OPEN_REGISTER_SCREEN');
		} else {
			UtilitiesService.backLoginScreen();
		}
	};

	function validPayments(payments) {
		var invalidPayment;
		return payments.every(function (payment) {
			var isValid = payment.IDSANGRIAAUTO == 'S' || (payment.IDSANGRIAAUTO == 'N' && payment.LABELVRMOVIVEND);
			if (!isValid) {
				ScreenService.showMessage('O tipo de recebimento ' + payment.NMTIPORECE + ' deve ter o valor preenchido.');
			}
			return isValid;
		});
	}

	this.getClosingPayments = function (widget) {
		OperatorRepository.findOne().then(function (operatorData) {
			RegisterService.getClosingPayments(operatorData.chave).then(function (data) {
				if (data.length === 0) {
					RegisterClosingPayments.clearAll();
					if (RegisterService.getClosingOnLogin()) {
						ScreenService.showMessage("Existe movimentação para o dia anterior, o caixa deve ser fechado. Informe os valores movimentados para cada tipo de recebimento.");
					}
					widget.reload();
				}
				else {
					var unpaidTables = data[0].unpaidTables;
					RegisterClosingPayments.save(data[0].payments).then(function (){

						if (_.isEmpty(data[0].payments)){
							RegisterClosingPayments.clearAll();
						}

						if (unpaidTables){
							ScreenService.confirmMessage(
						        'Existem mesas abertas. Deseja continuar?',
						        'question',
						        function () {
						            if (RegisterService.getClosingOnLogin()) {
										ScreenService.showMessage("Existe movimentação para o dia anterior, o caixa deve ser fechado. Informe os valores movimentados para cada tipo de recebimento.");
									}
									widget.reload();
						        },
						        function (){
						        	ScreenService.goBack();
						        }
						    );
						}
						else {
							if (RegisterService.getClosingOnLogin()) {
								ScreenService.showMessage("Existe movimentação para o dia anterior, o caixa deve ser fechado. Informe os valores movimentados para cada tipo de recebimento.");
							}
							widget.reload();
						}
					});
				}
			});
		});
	};

	this.openPopupPaymentValue = function (widget) {
		var row = widget.currentRow;

		if (row.IDSANGRIAAUTO !== 'S') {
			var widgetPopup = widget.container.getWidget('paymentValue');

			widgetPopup.getField('LABELVRMOVIVEND').setValue(row.VRMOVIVEND);
			ScreenService.openPopup(widgetPopup);
		}
	};

	this.savePaymentValue = function (widgetEdit, paymentGrid) {
		var VRMOVIVEND = UtilitiesService.getFloat(widgetEdit.currentRow.LABELVRMOVIVEND);
		if ((typeof VRMOVIVEND !== 'number') || (isNaN(VRMOVIVEND)) || (VRMOVIVEND < 0)) {
			ScreenService.showMessage('Informe um valor válido.');
		} else {
			VRMOVIVEND = Math.abs(VRMOVIVEND);
			paymentGrid.currentRow.LABELVRMOVIVEND = UtilitiesService.toCurrency(VRMOVIVEND);
			paymentGrid.currentRow.VRMOVIVEND = VRMOVIVEND;
			ScreenService.showLoader();
			ScreenService.closePopup();
			setTimeout( function(){
				paymentGrid.redraw(true);
				setTimeout( function(){ paymentGrid.redraw(true); }, 400);
				setTimeout( function(){ paymentGrid.redraw(true); ScreenService.hideLoader(); }, 500);
			}, 100);
		}
	};

	this.handleShowSideMenu = function (container) {
		OperatorRepository.findOne().then(function (operatorData) {
			if (_.get(operatorData, 'obrigaFechamento', false) === true) {
				container.showMenu = false;
			} else {
				container.showMenu = true;
			}
		});
	};

	this.handleEnterButton = function (args) {
		var keyCode = args.e.keyCode;
		if (keyCode === 9 || keyCode === 13) {
			UtilitiesService.handleCloseKeyboard();
			var widget = args.owner.field.widget;

			if (widget.name === 'openRegisterWidget')
				this.openRegister(widget);
			else if (widget.name === 'paymentValue')
				this.savePaymentValue(widget, widget.container.widgets[0]);
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('RegisterController', RegisterController);
});